<?php
//
// "$Id: documentation.php 39 2004-11-02 17:12:32Z mike $"
//
// Documentation page...
//

//
// Include necessary headers...
//

include_once "phplib/html.php";
include_once "phplib/common.php";


//
// Get the web server path information and serve the named file as needed...
//

if (array_key_exists("PATH_INFO", $_SERVER) &&
    $_SERVER["PATH_INFO"] != "/" &&
    $_SERVER["PATH_INFO"] != "")
{
  $path = "$_SERVER[PATH_INFO]";

  if (fnmatch("*.gif", $path))
    $type = "gif";
  else if (fnmatch("*.jpg", $path))
    $type = "jpeg";
  else if (fnmatch("*.png", $path))
    $type = "png";
  else
    $type = "html";

  if (strstr($path, ".."))
  {
    if ($type == "html")
    {
      html_header("Documentation Error", "../");

      print("<h1>Documentation Error</h1>\n"
           ."<p>The path '$path' is bad.</p>\n");

      html_footer("../");
    }
  }
  else
  {
    $fp = fopen("docfiles$path", "rb");
    if (!$fp)
    {
      if ($type == "html")
      {
	html_header("Documentation Error", "../");

	print("<h1>Documentation Error</h1>\n"
             ."<p>Unable to open path '$path'.</p>\n");

	html_footer("../");
      }
    }
    else if ($type == "html")
    {
      html_header("Documentation", "../");

      $saw_body = 0;
      $last_nav = 0;

      while ($line = fgets($fp, 1024))
      {
        if (strstr($line, "<BODY"))
	{
	  $saw_body = 1;
	}
        else if (strstr($line, "<body"))
	{
	  $saw_body = 1;

	  html_start_links(1);
	  html_link("Comments", "#_USER_COMMENTS");
	  html_end_links();
	}
	else if (stristr($line, "</BODY>"))
	{
	  break;
	}
	else if ($saw_body)
	{
	  if (strstr($line, ">Contents</A") ||
	      strstr($line, ">Previous</A>") ||
	      strstr($line, ">Next</A>"))
	  {
	    if ($last_nav)
	      print("|\n");
	    else
	      print("[ <A HREF='#_USER_COMMENTS'>Comments</a></li> |\n");

            $last_nav = 1;
	  }
	  else if (strstr($line, "<HR"))
	  {
	    if ($last_nav)
	      print("]\n");

	    $last_nav = 0;
	  }

	  print($line);
	}
      }

      fclose($fp);

      if ($last_nav)
        print("]\n");

      print("<hr noshade/>\n"
           ."<h2><a name='_USER_COMMENTS'>User Comments</a> [&nbsp;"
	   ."<a href='../comment.php?r0+pdocumentation.php$path'>Add&nbsp;Comment</a>"
	   ."&nbsp;]</h2>\n");

      $num_comments = show_comments("documentation.php$path", "../");

      if ($num_comments == 0)
        print("<p>No comments for this page.</p>\n");

      html_footer("../");
    }
    else
    {
      header("Content-Type: image/$type");
      
      print(fread($fp, filesize("docfiles$path")));

      fclose($fp);
    }
  }
}
else
{
  html_header("Documentation");

?>

<h1>Documentation</h1>

<p>You can view the Newsd documentation in a number of
formats on-line:</p>

<ul>

	<li>Man Pages:<ul>

		<li><a href='documentation.php/newsd.html'>newsd(8)</a></li>

		<li><a href='documentation.php/newsd.conf.html'>newsd.conf(5)</a></li>

	</ul></li>

	<li>Release Notes:<ul>

		<li><a href='relnotes.php#1.44rc2'>1.44rc2</a></li>

	</ul></li>

	<li>Developer Documentation:<ul>

<!--		<li><a href='newsd-cmp.php'>Configuration Management Plan</a></li>-->

		<li><a href='roadmap.php'>Development Roadmap</a></li>


<!--
		<li><a href='newsd-sdd.php'>Software Design Description</a></li>

		<li><a href='newsd-stp.php'>Software Test Plan</a></li>
-->

	</ul></li>

</ul>

<?php

  html_footer();
}

//
// End of "$Id: documentation.php 39 2004-11-02 17:12:32Z mike $".
//
?>
